commit 3106e8ccdc0107c1fd3f92eaef77ea9bb856803b
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Thu Mar 21 17:48:56 2019 +0100

    Updated to AMiRo-LLD 1.1:
    - Implementation of periphAL has been modified accordingly.
    - GPIOs are not encoded as port/pad tuple, but as lines
    - Some unittests have been updated due to driver changes.

diff --git a/core/inc/aos_system.h b/core/inc/aos_system.h
index dab3c8e..c4dc1bb 100644
--- a/core/inc/aos_system.h
+++ b/core/inc/aos_system.h
@@ -235,6 +235,7 @@ extern "C" {
   void aosSysStop(void);
   void aosSysDeinit(void);
   void aosSysShutdownFinal(aos_shutdown_t shutdown);
+  palcallback_t aosSysGetStdIntCallback(void);
 #if defined(__cplusplus)
 }
 #endif /* defined(__cplusplus) */
diff --git a/core/src/aos_main.cpp b/core/src/aos_main.cpp
index 783e225..9aff409 100644
--- a/core/src/aos_main.cpp
+++ b/core/src/aos_main.cpp
@@ -952,12 +952,15 @@ int main(void)
 #endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_2_ARGS) */
 #endif /* defined(AMIROOS_CFG_MAIN_INIT_HOOK_2) */
 
-  // AMiRo-OS and custom OS additions (if any)
+  // AMiRo-OS, additional interrupts and custom OS additions (if any)
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true)
   aosSysInit(moduleShellPrompt);
 #else /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
   aosSysInit();
 #endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#if defined(MODULE_INIT_INTERRUPTS)
+  MODULE_INIT_INTERRUPTS();
+#endif
 #if defined(MODULE_INIT_OS_EXTRA)
   MODULE_INIT_OS_EXTRA();
 #endif /* defined(MODULE_INIT_OS_EXTRA) */
@@ -998,12 +1001,12 @@ int main(void)
 #if defined(MODULE_INIT_PERIPHERY_COMM)
   MODULE_INIT_PERIPHERY_COMM();
 #endif /* defined(MODULE_INIT_PERIPHERY_COMM) */
-#if (SSSP_STAGE3_ENABLE == true )
+#if ((SSSP_STAGE3_ENABLE == true) && (HAL_USE_CAN == TRUE))
   // CAN
   if (MODULE_HAL_CAN.state == CAN_STOP) {
     canStart(&MODULE_HAL_CAN, &moduleHalCanConfig);
   }
-#endif /* (SSSP_STAGE3_ENABLE == true) */
+#endif /* (SSSP_STAGE3_ENABLE == true) && (HAL_USE_CAN == TRUE) */
   // user interface (if any)
 #if defined(MODULE_HAL_PROGIF)
   aosIOChannelInit(&_stdiochannel, (BaseAsynchronousChannel*)&MODULE_HAL_PROGIF);
diff --git a/core/src/aos_system.c b/core/src/aos_system.c
index c168be4..afa6fee 100644
--- a/core/src/aos_system.c
+++ b/core/src/aos_system.c
@@ -672,14 +672,14 @@ static int _shellcmd_kerneltestcb(BaseSequentialStream* stream, int argc, char*
 /**
  * @brief   Generic callback function for GPIO interrupts.
  *
- * @param[in] args   Pointer to the GPIO pad identifier.
+ * @param[in] args   Pointer to the GPIO line identifier.
  */
 static void _intCallback(void* args)
 {
-  aosDbgCheck((args != NULL) && (*((iopadid_t*)args) < sizeof(eventflags_t) * 8));
+  aosDbgCheck((args != NULL) && (*((ioline_t*)args) != PAL_NOLINE) && (PAL_PAD(*((ioline_t*)args)) < sizeof(eventflags_t) * 8));
 
   chSysLockFromISR();
-  chEvtBroadcastFlagsI(&aos.events.io, AOS_IOEVENT_FLAG(*((iopadid_t*)args)));
+  chEvtBroadcastFlagsI(&aos.events.io, AOS_IOEVENT_FLAG(PAL_PAD(*((ioline_t*)args))));
   chSysUnlockFromISR();
 
   return;
@@ -690,11 +690,11 @@ static void _intCallback(void* args)
 /**
  * @brief   Callback function for the Sync signal interrupt.
  *
- * @param[in] args   Pointer to the GPIO pad identifier.
+ * @param[in] args   Pointer to the GPIO line identifier.
  */
 static void _signalSyncCallback(void *args)
 {
-  aosDbgCheck((args != NULL) && (*((iopadid_t*)args) < sizeof(eventflags_t) * 8));
+  aosDbgCheck((args != NULL) && (*((ioline_t*)args) != PAL_NOLINE) && (PAL_PAD(*((ioline_t*)args)) < sizeof(eventflags_t) * 8));
 
   apalControlGpioState_t s_state;
   aos_timestamp_t uptime;
@@ -723,7 +723,7 @@ static void _signalSyncCallback(void *args)
     }
   }
   // broadcast event
-  chEvtBroadcastFlagsI(&aos.events.io, AOS_IOEVENT_FLAG(*((iopadid_t*)args)));
+  chEvtBroadcastFlagsI(&aos.events.io, AOS_IOEVENT_FLAG(PAL_PAD(*((ioline_t*)args))));
   chSysUnlockFromISR();
 
   return;
@@ -840,30 +840,26 @@ void aosSysInit(void)
   /* interrupt setup */
 #if (AMIROOS_CFG_SSSP_ENABLE == true)
   // PD signal
-  palSetPadCallback(moduleSsspGpioPd.gpio->port, moduleSsspGpioPd.gpio->pad, _intCallback, &moduleSsspGpioPd.gpio->pad);
-  palEnablePadEvent(moduleSsspGpioPd.gpio->port, moduleSsspGpioPd.gpio->pad, APAL2CH_EDGE(moduleSsspGpioPd.meta.edge));
+  palSetLineCallback(moduleSsspGpioPd.gpio->line, _intCallback, &moduleSsspGpioPd.gpio->line);
+  palEnableLineEvent(moduleSsspGpioPd.gpio->line, APAL2CH_EDGE(moduleSsspGpioPd.meta.edge));
   // SYNC signal
 #if (AMIROOS_CFG_SSSP_MASTER == true)
-  palSetPadCallback(moduleSsspGpioSync.gpio->port, moduleSsspGpioSync.gpio->pad, _intCallback, &moduleSsspGpioSync.gpio->pad);
+  palSetLineCallback(moduleSsspGpioSync.gpio->line, _intCallback, &moduleSsspGpioSync.gpio->line);
 #else /* (AMIROOS_CFG_SSSP_MASTER == true) */
-  palSetPadCallback(moduleSsspGpioSync.gpio->port, moduleSsspGpioSync.gpio->pad, _signalSyncCallback, &moduleSsspGpioSync.gpio->pad);
+  palSetLineCallback(moduleSsspGpioSync.gpio->line, _signalSyncCallback, &moduleSsspGpioSync.gpio->line);
 #endif /* (AMIROOS_CFG_SSSP_MASTER == true) */
-  palEnablePadEvent(moduleSsspGpioSync.gpio->port, moduleSsspGpioSync.gpio->pad, APAL2CH_EDGE(moduleSsspGpioSync.meta.edge));
+  palEnableLineEvent(moduleSsspGpioSync.gpio->line, APAL2CH_EDGE(moduleSsspGpioSync.meta.edge));
 #if (AMIROOS_CFG_SSSP_STACK_START != true)
   // DN signal
-  palSetPadCallback(moduleSsspGpioDn.gpio->port, moduleSsspGpioDn.gpio->pad, _intCallback, &moduleSsspGpioDn.gpio->pad);
-  palEnablePadEvent(moduleSsspGpioDn.gpio->port, moduleSsspGpioDn.gpio->pad, APAL2CH_EDGE(moduleSsspGpioDn.meta.edge));
+  palSetLineCallback(moduleSsspGpioDn.gpio->line, _intCallback, &moduleSsspGpioDn.gpio->line);
+  palEnableLineEvent(moduleSsspGpioDn.gpio->line, APAL2CH_EDGE(moduleSsspGpioDn.meta.edge));
 #endif /* (AMIROOS_CFG_SSSP_STACK_START != true) */
 #if (AMIROOS_CFG_SSSP_STACK_END != true)
   // UP signal
-  palSetPadCallback(moduleSsspGpioUp.gpio->port, moduleSsspGpioUp.gpio->pad, _intCallback, &moduleSsspGpioUp.gpio->pad);
-  palEnablePadEvent(moduleSsspGpioUp.gpio->port, moduleSsspGpioUp.gpio->pad, APAL2CH_EDGE(moduleSsspGpioUp.meta.edge));
+  palSetLineCallback(moduleSsspGpioUp.gpio->line, _intCallback, &moduleSsspGpioUp.gpio->line);
+  palEnableLineEvent(moduleSsspGpioUp.gpio->line, APAL2CH_EDGE(moduleSsspGpioUp.meta.edge));
 #endif /* (AMIROOS_CFG_SSSP_STACK_END != true) */
 #endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
-#if defined(MODULE_INIT_INTERRUPTS)
-  // further interrupt signals
-  MODULE_INIT_INTERRUPTS();
-#endif /* defined(MODULE_INIT_INTERRUPTS) */
 
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true)
   /* init shell */
@@ -1168,4 +1164,14 @@ void aosSysShutdownFinal(aos_shutdown_t shutdown)
   return;
 }
 
+/**
+ * @brief   Generic callback function for GPIO interrupts.
+ *
+ * @param[in] args   Pointer to the GPIO pad identifier.
+ */
+palcallback_t aosSysGetStdIntCallback(void)
+{
+  return _intCallback;
+}
+
 /** @} */
diff --git a/modules/DiWheelDrive_1-1/alldconf.h b/modules/DiWheelDrive_1-1/alldconf.h
index bc3cf36..9a2c97b 100644
--- a/modules/DiWheelDrive_1-1/alldconf.h
+++ b/modules/DiWheelDrive_1-1/alldconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_LLD_CFG_
 #define AMIRO_LLD_CFG_VERSION_MAJOR             1
-#define AMIRO_LLD_CFG_VERSION_MINOR             0
+#define AMIRO_LLD_CFG_VERSION_MINOR             1
 
 /**
  * @brief   Width of the apalTime_t data type.
diff --git a/modules/DiWheelDrive_1-1/module.c b/modules/DiWheelDrive_1-1/module.c
index 7601015..77f7e43 100644
--- a/modules/DiWheelDrive_1-1/module.c
+++ b/modules/DiWheelDrive_1-1/module.c
@@ -111,8 +111,8 @@ SerialConfig moduleHalProgIfConfig = {
 SPIConfig moduleHalSpiAccelerometerConfig = {
   /* circular buffer mode         */ false,
   /* callback function pointer    */ NULL,
-  /* chip select line port        */ GPIOC,
-  /* chip select line pad number  */ GPIOC_ACCEL_SS_N,
+  /* chip select line port        */ PAL_PORT(LINE_ACCEL_SS_N),
+  /* chip select line pad number  */ PAL_PAD(LINE_ACCEL_SS_N),
   /* CR1                          */ SPI_CR1_BR_0,
   /* CR2                          */ SPI_CR2_RXDMAEN | SPI_CR2_TXDMAEN,
 };
@@ -120,8 +120,8 @@ SPIConfig moduleHalSpiAccelerometerConfig = {
 SPIConfig moduleHalSpiGyroscopeConfig = {
   /* circular buffer mode         */ false,
   /* callback function pointer    */ NULL,
-  /* chip select line port        */ GPIOC,
-  /* chip select line pad number  */ GPIOC_GYRO_SS_N,
+  /* chip select line port        */ PAL_PORT(LINE_GYRO_SS_N),
+  /* chip select line pad number  */ PAL_PAD(LINE_GYRO_SS_N),
   /* CR1                          */ SPI_CR1_BR_0,
   /* CR2                          */ SPI_CR2_RXDMAEN | SPI_CR2_TXDMAEN,
 };
@@ -139,8 +139,7 @@ SPIConfig moduleHalSpiGyroscopeConfig = {
  * @brief   LED output signal GPIO.
  */
 static apalGpio_t _gpioLed = {
-  /* port */ GPIOA,
-  /* pad  */ GPIOA_LED,
+  /* line */ LINE_LED,
 };
 ROMCONST apalControlGpio_t moduleGpioLed = {
   /* GPIO */ &_gpioLed,
@@ -155,8 +154,7 @@ ROMCONST apalControlGpio_t moduleGpioLed = {
  * @brief   POWER_EN output signal GPIO.
  */
 static apalGpio_t _gpioPowerEn = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_POWER_EN,
+  /* line */ LINE_POWER_EN,
 };
 ROMCONST apalControlGpio_t moduleGpioPowerEn = {
   /* GPIO */ &_gpioPowerEn,
@@ -171,8 +169,7 @@ ROMCONST apalControlGpio_t moduleGpioPowerEn = {
  * @brief   COMPASS_DRDY output signal GPIO.
  */
 static apalGpio_t _gpioCompassDrdy = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_COMPASS_DRDY,
+  /* line */ LINE_COMPASS_DRDY,
 };
 ROMCONST apalControlGpio_t moduleGpioCompassDrdy = {
   /* GPIO */ &_gpioCompassDrdy,
@@ -187,8 +184,7 @@ ROMCONST apalControlGpio_t moduleGpioCompassDrdy = {
  * @brief   IR_INT input signal GPIO.
  */
 static apalGpio_t _gpioIrInt = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_IR_INT,
+  /* line */ LINE_IR_INT,
 };
 ROMCONST apalControlGpio_t moduleGpioIrInt = {
   /* GPIO */ &_gpioIrInt,
@@ -203,8 +199,7 @@ ROMCONST apalControlGpio_t moduleGpioIrInt = {
  * @brief   GYRO_DRDY input signal GPIO.
  */
 static apalGpio_t _gpioGyroDrdy = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_GYRO_DRDY,
+  /* line */ LINE_GYRO_DRDY,
 };
 ROMCONST apalControlGpio_t moduleGpioGyroDrdy = {
   /* GPIO */ &_gpioGyroDrdy,
@@ -219,8 +214,7 @@ ROMCONST apalControlGpio_t moduleGpioGyroDrdy = {
  * @brief   SYS_UART_UP bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysUartUp = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_SYS_UART_UP,
+  /* line */ LINE_SYS_UART_UP,
 };
 ROMCONST apalControlGpio_t moduleGpioSysUartUp = {
   /* GPIO */ &_gpioSysUartUp,
@@ -235,8 +229,7 @@ ROMCONST apalControlGpio_t moduleGpioSysUartUp = {
  * @brief   ACCEL_INT input signal GPIO.
  */
 static apalGpio_t _gpioAccelInt = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_ACCEL_INT_N,
+  /* line */ LINE_ACCEL_INT_N,
 };
 ROMCONST apalControlGpio_t moduleGpioAccelInt = {
   /* GPIO */ &_gpioAccelInt,
@@ -251,8 +244,7 @@ ROMCONST apalControlGpio_t moduleGpioAccelInt = {
  * @brief   SYS_SNYC bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysSync = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_INT_N,
+  /* line */ LINE_SYS_INT_N,
 };
 ROMCONST apalControlGpio_t  moduleGpioSysSync = {
   /* GPIO */ &_gpioSysSync,
@@ -267,8 +259,7 @@ ROMCONST apalControlGpio_t  moduleGpioSysSync = {
  * @brief   PATH_DCSTAT input signal GPIO.
  */
 static apalGpio_t _gpioPathDcStat = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_PATH_DCSTAT,
+  /* line */ LINE_PATH_DCSTAT,
 };
 ROMCONST apalControlGpio_t moduleGpioPathDcStat = {
   /* GPIO */ &_gpioPathDcStat,
@@ -283,8 +274,7 @@ ROMCONST apalControlGpio_t moduleGpioPathDcStat = {
  * @brief   PATH_DCEN output signal GPIO.
  */
 static apalGpio_t _gpioPathDcEn = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_PATH_DCEN,
+  /* line */ LINE_PATH_DCEN,
 };
 ROMCONST apalControlGpio_t moduleGpioPathDcEn = {
   /* GPIO */ &_gpioPathDcEn,
@@ -299,8 +289,7 @@ ROMCONST apalControlGpio_t moduleGpioPathDcEn = {
  * @brief   SYS_PD bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysPd = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_PD_N,
+  /* line */ LINE_SYS_PD_N,
 };
 ROMCONST apalControlGpio_t moduleGpioSysPd = {
   /* GPIO */ &_gpioSysPd,
@@ -315,8 +304,7 @@ ROMCONST apalControlGpio_t moduleGpioSysPd = {
  * @brief   SYS_REG_EN input signal GPIO.
  */
 static apalGpio_t _gpioSysRegEn = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_REG_EN,
+  /* line */ LINE_SYS_REG_EN,
 };
 ROMCONST apalControlGpio_t moduleGpioSysRegEn = {
   /* GPIO */ &_gpioSysRegEn,
@@ -331,8 +319,7 @@ ROMCONST apalControlGpio_t moduleGpioSysRegEn = {
  * @brief   SYS_WARMRST bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysWarmrst = {
-  /* port */ GPIOD,
-  /* pad  */ GPIOD_SYS_WARMRST_N,
+  /* line */ LINE_SYS_WARMRST_N,
 };
 ROMCONST apalControlGpio_t moduleGpioSysWarmrst = {
   /* GPIO */ &_gpioSysWarmrst,
diff --git a/modules/DiWheelDrive_1-1/module.h b/modules/DiWheelDrive_1-1/module.h
index c05399a..e47d147 100644
--- a/modules/DiWheelDrive_1-1/module.h
+++ b/modules/DiWheelDrive_1-1/module.h
@@ -242,52 +242,52 @@ extern ROMCONST apalControlGpio_t moduleGpioSysWarmrst;
 /**
  * @brief   Event flag to be set on a SYS_SYNC interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSSYNC          AOS_IOEVENT_FLAG(GPIOC_SYS_INT_N)
+#define MODULE_OS_IOEVENTFLAGS_SYSSYNC          AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_INT_N))
 
 /**
  * @brief   Event flag to be set on a SYS_WARMRST interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSWARMRST       AOS_IOEVENT_FLAG(GPIOD_SYS_WARMRST_N)
+#define MODULE_OS_IOEVENTFLAGS_SYSWARMRST       AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_WARMRST_N))
 
 /**
  * @brief   Event flag to be set on a PATH_DCSTAT interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_PATHDCSTAT       AOS_IOEVENT_FLAG(GPIOC_PATH_DCEN)
+#define MODULE_OS_IOEVENTFLAGS_PATHDCSTAT       AOS_IOEVENT_FLAG(PAL_PAD(LINE_PATH_DCEN))
 
 /**
  * @brief   Event flag to be set on a COMPASS_DRDY interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_COMPASSDRDY      AOS_IOEVENT_FLAG(GPIOB_COMPASS_DRDY)
+#define MODULE_OS_IOEVENTFLAGS_COMPASSDRDY      AOS_IOEVENT_FLAG(PAL_PAD(LINE_COMPASS_DRDY))
 
 /**
  * @brief   Event flag to be set on a SYS_PD interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSPD            AOS_IOEVENT_FLAG(GPIOC_SYS_PD_N)
+#define MODULE_OS_IOEVENTFLAGS_SYSPD            AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_PD_N))
 
 /**
  * @brief   Event flag to be set on a SYS_REG_EN interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSREGEN         AOS_IOEVENT_FLAG(GPIOC_SYS_REG_EN)
+#define MODULE_OS_IOEVENTFLAGS_SYSREGEN         AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_REG_EN))
 
 /**
  * @brief   Event flag to be set on a IR_INT interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_IRINT            AOS_IOEVENT_FLAG(GPIOB_IR_INT)
+#define MODULE_OS_IOEVENTFLAGS_IRINT            AOS_IOEVENT_FLAG(PAL_PAD(LINE_IR_INT))
 
 /**
  * @brief   Event flag to be set on a GYRO_DRDY interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_GYRODRDY         AOS_IOEVENT_FLAG(GPIOB_GYRO_DRDY)
+#define MODULE_OS_IOEVENTFLAGS_GYRODRDY         AOS_IOEVENT_FLAG(PAL_PAD(LINE_GYRO_DRDY))
 
 /**
  * @brief   Event flag to be set on a SYS_UART_UP interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSUARTUP        AOS_IOEVENT_FLAG(GPIOB_SYS_UART_UP)
+#define MODULE_OS_IOEVENTFLAGS_SYSUARTUP        AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_UART_UP))
 
 /**
  * @brief   Event flag to be set on a ACCEL_INT interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_ACCELINT         AOS_IOEVENT_FLAG(GPIOB_ACCEL_INT_N)
+#define MODULE_OS_IOEVENTFLAGS_ACCELINT         AOS_IOEVENT_FLAG(PAL_PAD(LINE_ACCEL_INT_N))
 
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
 /**
@@ -309,26 +309,26 @@ extern ROMCONST char* moduleShellPrompt;
  */
 #define MODULE_INIT_INTERRUPTS() {                                            \
   /* COMPASS_DRDY */                                                          \
-  palSetPadCallback(moduleGpioCompassDrdy.gpio->port, moduleGpioCompassDrdy.gpio->pad, _intCallback, &moduleGpioCompassDrdy.gpio->pad); \
-  palEnablePadEvent(moduleGpioCompassDrdy.gpio->port, moduleGpioCompassDrdy.gpio->pad, APAL2CH_EDGE(moduleGpioCompassDrdy.meta.edge));  \
+  palSetLineCallback(moduleGpioCompassDrdy.gpio->line, aosSysGetStdIntCallback(), &moduleGpioCompassDrdy.gpio->line); \
+  palEnableLineEvent(moduleGpioCompassDrdy.gpio->line, APAL2CH_EDGE(moduleGpioCompassDrdy.meta.edge));                \
   /* IR_INT */                                                                \
-  palSetPadCallback(moduleGpioIrInt.gpio->port, moduleGpioIrInt.gpio->pad, _intCallback, &moduleGpioIrInt.gpio->pad); \
-  palEnablePadEvent(moduleGpioIrInt.gpio->port, moduleGpioIrInt.gpio->pad, APAL2CH_EDGE(moduleGpioIrInt.meta.edge));  \
+  palSetLineCallback(moduleGpioIrInt.gpio->line, aosSysGetStdIntCallback(), &moduleGpioIrInt.gpio->line); \
+  palEnableLineEvent(moduleGpioIrInt.gpio->line, APAL2CH_EDGE(moduleGpioIrInt.meta.edge));                \
   /* GYRO_DRDY */                                                             \
-  palSetPadCallback(moduleGpioGyroDrdy.gpio->port, moduleGpioGyroDrdy.gpio->pad, _intCallback, &moduleGpioGyroDrdy.gpio->pad);  \
-  palEnablePadEvent(moduleGpioGyroDrdy.gpio->port, moduleGpioGyroDrdy.gpio->pad, APAL2CH_EDGE(moduleGpioGyroDrdy.meta.edge));   \
+  palSetLineCallback(moduleGpioGyroDrdy.gpio->line, aosSysGetStdIntCallback(), &moduleGpioGyroDrdy.gpio->line); \
+  palEnableLineEvent(moduleGpioGyroDrdy.gpio->line, APAL2CH_EDGE(moduleGpioGyroDrdy.meta.edge));                \
   /* ACCEL_INT */                                                             \
-  palSetPadCallback(moduleGpioAccelInt.gpio->port, moduleGpioAccelInt.gpio->pad, _intCallback, &moduleGpioAccelInt.gpio->pad);  \
-  palEnablePadEvent(moduleGpioAccelInt.gpio->port, moduleGpioAccelInt.gpio->pad, APAL2CH_EDGE(moduleGpioAccelInt.meta.edge));   \
+  palSetLineCallback(moduleGpioAccelInt.gpio->line, aosSysGetStdIntCallback(), &moduleGpioAccelInt.gpio->line); \
+  palEnableLineEvent(moduleGpioAccelInt.gpio->line, APAL2CH_EDGE(moduleGpioAccelInt.meta.edge));                \
   /* PATH_DCSTAT */                                                           \
-  palSetPadCallback(moduleGpioPathDcStat.gpio->port, moduleGpioPathDcStat.gpio->pad, _intCallback, &moduleGpioPathDcStat.gpio->pad);  \
-  palEnablePadEvent(moduleGpioPathDcStat.gpio->port, moduleGpioPathDcStat.gpio->pad, APAL2CH_EDGE(moduleGpioPathDcStat.meta.edge));   \
+  palSetLineCallback(moduleGpioPathDcStat.gpio->line, aosSysGetStdIntCallback(), &moduleGpioPathDcStat.gpio->line); \
+  palEnableLineEvent(moduleGpioPathDcStat.gpio->line, APAL2CH_EDGE(moduleGpioPathDcStat.meta.edge));                \
   /* SYS_REG_EN */                                                            \
-  palSetPadCallback(moduleGpioSysRegEn.gpio->port, moduleGpioSysRegEn.gpio->pad, _intCallback, &moduleGpioSysRegEn.gpio->pad);  \
-  palEnablePadEvent(moduleGpioSysRegEn.gpio->port, moduleGpioSysRegEn.gpio->pad, APAL2CH_EDGE(moduleGpioSysRegEn.meta.edge));   \
+  palSetLineCallback(moduleGpioSysRegEn.gpio->line, aosSysGetStdIntCallback(), &moduleGpioSysRegEn.gpio->line); \
+  palEnableLineEvent(moduleGpioSysRegEn.gpio->line, APAL2CH_EDGE(moduleGpioSysRegEn.meta.edge));                \
   /* SYS_WARMRST */                                                           \
-  palSetPadCallback(moduleGpioSysWarmrst.gpio->port, moduleGpioSysWarmrst.gpio->pad, _intCallback, &moduleGpioSysWarmrst.gpio->pad);  \
-  palEnablePadEvent(moduleGpioSysWarmrst.gpio->port, moduleGpioSysWarmrst.gpio->pad, APAL2CH_EDGE(moduleGpioSysWarmrst.meta.edge));   \
+  palSetLineCallback(moduleGpioSysWarmrst.gpio->line, aosSysGetStdIntCallback(), &moduleGpioSysWarmrst.gpio->line); \
+  palEnableLineEvent(moduleGpioSysWarmrst.gpio->line, APAL2CH_EDGE(moduleGpioSysWarmrst.meta.edge));                \
 }
 
 /**
diff --git a/modules/DiWheelDrive_1-2/alldconf.h b/modules/DiWheelDrive_1-2/alldconf.h
index de0d826..c26ee9a 100644
--- a/modules/DiWheelDrive_1-2/alldconf.h
+++ b/modules/DiWheelDrive_1-2/alldconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_LLD_CFG_
 #define AMIRO_LLD_CFG_VERSION_MAJOR             1
-#define AMIRO_LLD_CFG_VERSION_MINOR             0
+#define AMIRO_LLD_CFG_VERSION_MINOR             1
 
 /**
  * @brief   Width of the apalTime_t data type.
diff --git a/modules/DiWheelDrive_1-2/module.c b/modules/DiWheelDrive_1-2/module.c
index ab17198..96041bb 100644
--- a/modules/DiWheelDrive_1-2/module.c
+++ b/modules/DiWheelDrive_1-2/module.c
@@ -121,8 +121,7 @@ SerialConfig moduleHalProgIfConfig = {
  * @brief   LED output signal GPIO.
  */
 static apalGpio_t _gpioLed = {
-  /* port */ GPIOA,
-  /* pad  */ GPIOA_LED,
+  /* line */ LINE_LED,
 };
 ROMCONST apalControlGpio_t moduleGpioLed = {
   /* GPIO */ &_gpioLed,
@@ -137,8 +136,7 @@ ROMCONST apalControlGpio_t moduleGpioLed = {
  * @brief   POWER_EN output signal GPIO.
  */
 static apalGpio_t _gpioPowerEn = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_POWER_EN,
+  /* line */ LINE_POWER_EN,
 };
 ROMCONST apalControlGpio_t moduleGpioPowerEn = {
   /* GPIO */ &_gpioPowerEn,
@@ -153,8 +151,7 @@ ROMCONST apalControlGpio_t moduleGpioPowerEn = {
  * @brief   IR_INT input signal GPIO.
  */
 static apalGpio_t _gpioIrInt = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_IR_INT,
+  /* line */ LINE_IR_INT,
 };
 ROMCONST apalControlGpio_t moduleGpioIrInt = {
   /* GPIO */ &_gpioIrInt,
@@ -169,8 +166,7 @@ ROMCONST apalControlGpio_t moduleGpioIrInt = {
  * @brief   SYS_UART_UP bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysUartUp = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_SYS_UART_UP,
+  /* line */ LINE_SYS_UART_UP,
 };
 ROMCONST apalControlGpio_t moduleGpioSysUartUp = {
   /* GPIO */ &_gpioSysUartUp,
@@ -185,8 +181,7 @@ ROMCONST apalControlGpio_t moduleGpioSysUartUp = {
  * @brief   IMU_INT input signal GPIO.
  */
 static apalGpio_t _gpioImuInt = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_IMU_INT,
+  /* line */ LINE_IMU_INT,
 };
 ROMCONST apalControlGpio_t moduleGpioImuInt = {
   /* GPIO */ &_gpioImuInt,
@@ -201,8 +196,7 @@ ROMCONST apalControlGpio_t moduleGpioImuInt = {
  * @brief   SYS_SNYC bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysSync = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_INT_N,
+  /* line */ LINE_SYS_INT_N,
 };
 ROMCONST apalControlGpio_t  moduleGpioSysSync = {
   /* GPIO */ &_gpioSysSync,
@@ -217,8 +211,7 @@ ROMCONST apalControlGpio_t  moduleGpioSysSync = {
  * @brief   IMU_RESET output signal GPIO.
  */
 static apalGpio_t _gpioImuReset = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_IMU_RESET_N,
+  /* line */ LINE_IMU_RESET_N,
 };
 ROMCONST apalControlGpio_t  moduleGpioImuReset = {
   /* GPIO */ &_gpioImuReset,
@@ -233,8 +226,7 @@ ROMCONST apalControlGpio_t  moduleGpioImuReset = {
  * @brief   PATH_DCSTAT input signal GPIO.
  */
 static apalGpio_t _gpioPathDcStat = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_PATH_DCSTAT,
+  /* line */ LINE_PATH_DCSTAT,
 };
 ROMCONST apalControlGpio_t moduleGpioPathDcStat = {
   /* GPIO */ &_gpioPathDcStat,
@@ -249,8 +241,7 @@ ROMCONST apalControlGpio_t moduleGpioPathDcStat = {
  * @brief   PATH_DCEN output signal GPIO.
  */
 static apalGpio_t _gpioPathDcEn = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_PATH_DCEN,
+  /* line */ LINE_PATH_DCEN,
 };
 ROMCONST apalControlGpio_t moduleGpioPathDcEn = {
   /* GPIO */ &_gpioPathDcEn,
@@ -265,8 +256,7 @@ ROMCONST apalControlGpio_t moduleGpioPathDcEn = {
  * @brief   SYS_PD bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysPd = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_PD_N,
+  /* line */ LINE_SYS_PD_N,
 };
 ROMCONST apalControlGpio_t moduleGpioSysPd = {
   /* GPIO */ &_gpioSysPd,
@@ -281,8 +271,7 @@ ROMCONST apalControlGpio_t moduleGpioSysPd = {
  * @brief   SYS_REG_EN input signal GPIO.
  */
 static apalGpio_t _gpioSysRegEn = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_REG_EN,
+  /* line */ LINE_SYS_REG_EN,
 };
 ROMCONST apalControlGpio_t moduleGpioSysRegEn = {
   /* GPIO */ &_gpioSysRegEn,
@@ -297,8 +286,7 @@ ROMCONST apalControlGpio_t moduleGpioSysRegEn = {
  * @brief   IMU_BOOT_LOAD output signal GPIO.
  */
 static apalGpio_t _gpioImuBootLoad = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_IMU_BOOT_LOAD_N,
+  /* line */ LINE_IMU_BOOT_LOAD_N,
 };
 ROMCONST apalControlGpio_t moduleGpioImuBootLoad = {
   /* GPIO */ &_gpioImuBootLoad,
@@ -313,8 +301,7 @@ ROMCONST apalControlGpio_t moduleGpioImuBootLoad = {
  * @brief   IMU_BL_IND input signal GPIO.
  */
 static apalGpio_t _gpioImuBlInd = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_IMU_BL_IND,
+  /* line */ LINE_IMU_BL_IND,
 };
 ROMCONST apalControlGpio_t moduleGpioImuBlInd = {
   /* GPIO */ &_gpioImuBlInd,
@@ -329,8 +316,7 @@ ROMCONST apalControlGpio_t moduleGpioImuBlInd = {
  * @brief   SYS_WARMRST bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysWarmrst = {
-  /* port */ GPIOD,
-  /* pad  */ GPIOD_SYS_WARMRST_N,
+  /* line */ LINE_SYS_WARMRST_N,
 };
 ROMCONST apalControlGpio_t moduleGpioSysWarmrst = {
   /* GPIO */ &_gpioSysWarmrst,
diff --git a/modules/DiWheelDrive_1-2/module.h b/modules/DiWheelDrive_1-2/module.h
index 497616c..d5e3bbe 100644
--- a/modules/DiWheelDrive_1-2/module.h
+++ b/modules/DiWheelDrive_1-2/module.h
@@ -232,42 +232,42 @@ extern ROMCONST apalControlGpio_t moduleGpioSysWarmrst;
 /**
  * @brief   Event flag to be set on a SYS_SYNC interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSSYNC          AOS_IOEVENT_FLAG(GPIOC_SYS_INT_N)
+#define MODULE_OS_IOEVENTFLAGS_SYSSYNC          AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_INT_N))
 
 /**
  * @brief   Event flag to be set on a SYS_WARMRST interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSWARMRST       AOS_IOEVENT_FLAG(GPIOD_SYS_WARMRST_N)
+#define MODULE_OS_IOEVENTFLAGS_SYSWARMRST       AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_WARMRST_N))
 
 /**
  * @brief   Event flag to be set on a PATH_DCSTAT interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_PATHDCSTAT       AOS_IOEVENT_FLAG(GPIOC_PATH_DCEN)
+#define MODULE_OS_IOEVENTFLAGS_PATHDCSTAT       AOS_IOEVENT_FLAG(PAL_PAD(LINE_PATH_DCEN))
 
 /**
  * @brief   Event flag to be set on a SYS_PD interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSPD            AOS_IOEVENT_FLAG(GPIOC_SYS_PD_N)
+#define MODULE_OS_IOEVENTFLAGS_SYSPD            AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_PD_N))
 
 /**
  * @brief   Event flag to be set on a SYS_REG_EN interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSREGEN         AOS_IOEVENT_FLAG(GPIOC_SYS_REG_EN)
+#define MODULE_OS_IOEVENTFLAGS_SYSREGEN         AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_REG_EN))
 
 /**
  * @brief   Event flag to be set on a IR_INT interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_IRINT            AOS_IOEVENT_FLAG(GPIOB_IR_INT)
+#define MODULE_OS_IOEVENTFLAGS_IRINT            AOS_IOEVENT_FLAG(PAL_PAD(LINE_IR_INT))
 
 /**
  * @brief   Event flag to be set on a SYS_UART_UP interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSUARTUP        AOS_IOEVENT_FLAG(GPIOB_SYS_UART_UP)
+#define MODULE_OS_IOEVENTFLAGS_SYSUARTUP        AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_UART_UP))
 
 /**
  * @brief   Event flag to be set on a IMU_INT interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_IMUINT         AOS_IOEVENT_FLAG(GPIOB_IMU_INT)
+#define MODULE_OS_IOEVENTFLAGS_IMUINT         AOS_IOEVENT_FLAG(PAL_PAD(LINE_IMU_INT))
 
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
 /**
@@ -289,20 +289,20 @@ extern ROMCONST char* moduleShellPrompt;
  */
 #define MODULE_INIT_INTERRUPTS() {                                            \
   /* IR_INT */                                                                \
-  palSetPadCallback(moduleGpioIrInt.gpio->port, moduleGpioIrInt.gpio->pad, _intCallback, &moduleGpioIrInt.gpio->pad); \
-  palEnablePadEvent(moduleGpioIrInt.gpio->port, moduleGpioIrInt.gpio->pad, APAL2CH_EDGE(moduleGpioIrInt.meta.edge));  \
+  palSetLineCallback(moduleGpioIrInt.gpio->line, aosSysGetStdIntCallback(), &moduleGpioIrInt.gpio->line); \
+  palEnableLineEvent(moduleGpioIrInt.gpio->line, APAL2CH_EDGE(moduleGpioIrInt.meta.edge));                \
   /* IMU_INT */                                                               \
-  palSetPadCallback(moduleGpioImuInt.gpio->port, moduleGpioImuInt.gpio->pad, _intCallback, &moduleGpioImuInt.gpio->pad);  \
-  palEnablePadEvent(moduleGpioImuInt.gpio->port, moduleGpioImuInt.gpio->pad, APAL2CH_EDGE(moduleGpioImuInt.meta.edge));   \
+  palSetLineCallback(moduleGpioImuInt.gpio->line, aosSysGetStdIntCallback(), &moduleGpioImuInt.gpio->line); \
+  palEnableLineEvent(moduleGpioImuInt.gpio->line, APAL2CH_EDGE(moduleGpioImuInt.meta.edge));                \
   /* PATH_DCSTAT */                                                           \
-  palSetPadCallback(moduleGpioPathDcStat.gpio->port, moduleGpioPathDcStat.gpio->pad, _intCallback, &moduleGpioPathDcStat.gpio->pad);  \
-  palEnablePadEvent(moduleGpioPathDcStat.gpio->port, moduleGpioPathDcStat.gpio->pad, APAL2CH_EDGE(moduleGpioPathDcStat.meta.edge));   \
+  palSetLineCallback(moduleGpioPathDcStat.gpio->line, aosSysGetStdIntCallback(), &moduleGpioPathDcStat.gpio->line); \
+  palEnableLineEvent(moduleGpioPathDcStat.gpio->line, APAL2CH_EDGE(moduleGpioPathDcStat.meta.edge));                \
   /* SYS_REG_EN */                                                            \
-  palSetPadCallback(moduleGpioSysRegEn.gpio->port, moduleGpioSysRegEn.gpio->pad, _intCallback, &moduleGpioSysRegEn.gpio->pad);  \
-  palEnablePadEvent(moduleGpioSysRegEn.gpio->port, moduleGpioSysRegEn.gpio->pad, APAL2CH_EDGE(moduleGpioSysRegEn.meta.edge));   \
+  palSetLineCallback(moduleGpioSysRegEn.gpio->line, aosSysGetStdIntCallback(), &moduleGpioSysRegEn.gpio->line); \
+  palEnableLineEvent(moduleGpioSysRegEn.gpio->line, APAL2CH_EDGE(moduleGpioSysRegEn.meta.edge));                \
   /* SYS_WARMRST */                                                           \
-  palSetPadCallback(moduleGpioSysWarmrst.gpio->port, moduleGpioSysWarmrst.gpio->pad, _intCallback, &moduleGpioSysWarmrst.gpio->pad);  \
-  palEnablePadEvent(moduleGpioSysWarmrst.gpio->port, moduleGpioSysWarmrst.gpio->pad, APAL2CH_EDGE(moduleGpioSysWarmrst.meta.edge));   \
+  palSetLineCallback(moduleGpioSysWarmrst.gpio->line, aosSysGetStdIntCallback(), &moduleGpioSysWarmrst.gpio->line); \
+  palEnableLineEvent(moduleGpioSysWarmrst.gpio->line, APAL2CH_EDGE(moduleGpioSysWarmrst.meta.edge));                \
 }
 
 /**
diff --git a/modules/LightRing_1-0/alldconf.h b/modules/LightRing_1-0/alldconf.h
index 29aaa5c..8790738 100644
--- a/modules/LightRing_1-0/alldconf.h
+++ b/modules/LightRing_1-0/alldconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_LLD_CFG_
 #define AMIRO_LLD_CFG_VERSION_MAJOR             1
-#define AMIRO_LLD_CFG_VERSION_MINOR             0
+#define AMIRO_LLD_CFG_VERSION_MINOR             1
 
 /**
  * @brief   Width of the apalTime_t data type.
